<?php
/******************************
 * WoWRoster.net  Roster
 * Copyright 2002-2006
 * Licensed under the Creative Commons
 * "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * Short summary
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Full license information
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/legalcode
 * -----------------------------
 *
 * $Id: wowdb.php 63 2006-06-14 22:30:35Z mathos $
 *
 ******************************/
if(isset($_GET['skill']))
{
	
	$skill = $_GET['skill'];
	
	$skill = mysql_real_escape_string($skill);
	switch($skill)
	{
		case $wordings[$roster_conf['roster_lang']]['Alchemy']:
			$url = 'http://wow.allakhazam.com/db/skill.html?line=171&locale='.$roster_conf['roster_lang'];
			break;
		case $wordings[$roster_conf['roster_lang']]['Blacksmithing']:
			$url = 'http://wow.allakhazam.com/db/skill.html?line=164&locale='.$roster_conf['roster_lang'];
			break;
		case $wordings[$roster_conf['roster_lang']]['Cooking']:
			$url = 'http://wow.allakhazam.com/db/skill.html?line=185&locale='.$roster_conf['roster_lang'];
			break;
		case $wordings[$roster_conf['roster_lang']]['Enchanting']:
			$url = 'http://wow.allakhazam.com/db/skill.html?line=333&locale='.$roster_conf['roster_lang'];
			break;
		case $wordings[$roster_conf['roster_lang']]['Engineering']:
			$url = 'http://wow.allakhazam.com/db/skill.html?line=202&locale='.$roster_conf['roster_lang'];
			break;
		case $wordings[$roster_conf['roster_lang']]['First Aid']:
			$url = 'http://wow.allakhazam.com/db/skill.html?line=129&locale='.$roster_conf['roster_lang'];
			break;
		case $wordings[$roster_conf['roster_lang']]['LeatherWorking']:
			$url = 'http://wow.allakhazam.com/db/skill.html?line=165&locale='.$roster_conf['roster_lang'];
			break;
		case $wordings[$roster_conf['roster_lang']]['Tailoring']:
			$url = 'http://wow.allakhazam.com/db/skill.html?line=197&locale='.$roster_conf['roster_lang'];
			break;
		default:
			$url ='';
			break;
	}

}
ini_set ( 'safemode', false );
if (function_exists('curl_init'))
{
//	print 'coucou';
	$ch = curl_init($url);

	curl_setopt($ch, CURLOPT_TIMEOUT, 60);
//	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

	$contents = curl_exec($ch);

	curl_close($ch);
}
else
{
	if(ini_get('allow_url_fopen') == 1)
	{
		$contents = file_get_contents($url);
	}
	else {
		return $wordings[$roster_conf['roster_lang']]['mr_curlerror'];
	}
}
preg_match_all('/(?<=\<tr class=\"[dl]r\"\>)((.(?!\<\/tr))*)/si',$contents,$matches);
foreach ($matches[0] as $nr => $recipe)
{
	preg_match_all('/(\<td[\w \\\'\"=]*\>)(.*)(?=\<\/td)/mi',$recipe,$lines)."\n";
 	$recipes[$nr]['icon'] = $lines[2][0];
 	$recipes[$nr]['icon'] = str_replace("src=\"/images/icons", "src=\"".$roster_conf['roster_dir']."/".$roster_conf['interface_url']."Interface/Icons", $recipes[$nr]['icon']);
 	$recipes[$nr]['icon'] = str_replace(".png", ".".$roster_conf['img_suffix']."\" alt=\"" , $recipes[$nr]['icon']);
 	preg_match('/(\<a[^\>]* href=\"([^\"]*)\"\>)([^<]*)/i',$lines[2][1],$name);
 	$recipes[$nr]['name'] = $name[3];
 	preg_match('/href=\"([^\"]*)\"/i',$lines[2][5],$link);
 	//$recipes[$nr]['components'] = $lines[2][4];
	$recipes[$nr]['i_link'] = $link[1];
 	$recipes[$nr]['category'] = $lines[2][2];
 	$recipes[$nr]['skill'] = $lines[2][3];
 	preg_match('/(\<a[^\>]* href=\"([^\"]*)\"\>)([^<]*)(.*(\<a[^\>]* href=\"([^\"]*)\"\>\<span[^\>]*\>)([^<]*))?/i',$lines[2][1],$name);
	$recipes[$nr]['r_link'] = $name[2];
	if (isset($name[6]))
	{
 	$recipes[$nr]['pat_link'] = $name[6];
 	$recipes[$nr]['pat_name'] = $name[7];
	} 
}

$id = nametoid($_GET[cnameadd]);

$query = "select recipe_name from ".ROSTER_RECIPESTABLE." where member_id = '$id' and skill_name = '$skill';";
//$query = "select recipe_name from ".ROSTER_RECIPESTABLE." where member_id = '$id' and skill_name = '".$wordings[$roster_conf['roster_lang']][$skill]."';";

$results = $wowdb->query($query) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);

while($row = $wowdb->fetch_array($results))
{
	$known[] = $row['recipe_name'];
}

if(!is_array($known))
{
	$output = "<br />".$wordings[$roster_conf['roster_lang']]['professionunknown'];
	echo $output;
	return;
}

if(!is_array($recipes))
{
	$output = "<br />".$wordings[$roster_conf['roster_lang']]['failedretrieve'];
	echo $output;
	return;
}

foreach($recipes as $nr => $keys)
{
	$allrecipes[] = $keys['name'];	
}

$diff = array_diff($allrecipes, $known);

$skillsql = "select skill_level from ".ROSTER_SKILLSTABLE." where member_id = '$id' and skill_name = '$skill';";


if($skillres = $wowdb->query($skillsql)){
	$skillfet = $wowdb->fetch_assoc($skillres);
	list($skilllvl, $skillother) = explode(":", $skillfet['skill_level'], 2);
} else {
	$skilllvl = 0;
}

$content = '<br /><br />';
$content .= border('syellow', 'start', $wordings[$roster_conf['roster_lang']]['unknownrecipes']);
$content .= '
	<table width="100%" cellspacing="0" class="bodyline">
		<tr><th></th><th class="membersHeader">'.$wordings[$roster_conf['roster_lang']]['memberHeaderName'].'</th><th class="membersHeader">'.$wordings[$roster_conf['roster_lang']]['memberHeaderSkillLevel'].'</th><th class="membersHeader">'.$wordings[$roster_conf['roster_lang']]['bankAvailability'].'</th></tr>';

foreach($diff as $key => $value)
{

	if(strpos($recipes[$key]['icon'], "INV_Misc_QuestionMark"))
	{
		continue;
	}
	++$striping_counter;
	
	$link = "http://wow.allakhazam.com".$recipes[$key]['i_link'];
	$bankRecipe = "&nbsp;";
	if($recipes[$key]['pat_link'])
	{
		$plink = "http://wow.allakhazam.com".$recipes[$key]['pat_link'];
		$pname = $recipes[$key]['pat_name'];
		$ptotal = "<br /><a href=\"$plink\">$pname</a>";
		$bankRecipe = getBankRecipeString($pname);
	}
	
	if($recipes[$key]['skill'])
	{
		if($recipes[$key]['skill'] > $skilllvl)
		{
			$skillcolor = "hskillcolor";
		}
		else
		{
			if($recipes[$key]['skill'] < $skilllvl)
			{
				$skillcolor = "lskillcolor";
			}
			else {
				$skillcolor = "mskillcolor";
			}
			
		}
	}
	$content .=('
		<tr>
			<td class="membersRow'. (($striping_counter % 2) +1) .'">'.$recipes[$key]['icon'].'</td>
			<td class="membersRow'. (($striping_counter % 2) +1) .'"><a href="'.$link.'"> '.$value.'</a>'.(isset($ptotal) ? $ptotal : "").'</td>
			<td class="membersRow'. (($striping_counter % 2) +1) .'">'.(isset($skillcolor) ? "<span class=\"$skillcolor\">" : "").$recipes[$key]['skill'].(isset($skillcolor) ? "</span>" : "").'</td>
			<td class="membersRow'. (($striping_counter % 2) +1) .'">'.$bankRecipe.'</td>
		</tr>');
	
	unset($ptotal);
	unset($skillcolor);
}
$content .= '</table>'.border('syellow', 'end');


echo($content);



function nametoid($name)
{
	global $wowdb;
	
	if(ctype_digit($name))
	{
		return $name;
	}
	
	$sql = "SELECT member_id from `".ROSTER_MEMBERSTABLE."` where name = '".mysql_real_escape_string($name)."' LIMIT 1";
	
	$results = $wowdb->query($sql) or die_quietly($wowdb->error(),'Database Error',basename(__FILE__),__LINE__,$query);
	
	if($results)
	{
		$member_id_raw = $wowdb->fetch_assoc($results);
		$member_id = $member_id_raw['member_id'];
		return $member_id;
	}
	else {
		return FALSE;
	}
}

function getBankRecipeString($patname)
{
	global $wowdb, $roster_conf, $wordings; 
	$content = '';
	if($patname=='')
	{
		return "&nbsp;";
	}
	$patname = str_replace("'", "''", $patname);
	$filterPatQuery = " AND item.item_tooltip LIKE '%".$patname."%'";
	$itemQuery = "SELECT member.name as member_name, member.member_id as member_id, item.*, LEFT(item.item_id, (LOCATE(':',item.item_id)-1)) as real_itemid FROM `".ROSTER_ITEMSTABLE."` as item LEFT JOIN `".ROSTER_MEMBERSTABLE."` as member ON item.member_id=member.member_id WHERE member.".$roster_conf['banker_fieldname']." LIKE '%".$roster_conf['banker_rankname']."%' AND item.item_parent!='bags' AND item.item_parent!='equip'".$filterPatQuery." AND item.item_tooltip NOT LIKE '%".$wordings[$roster_conf['roster_lang']]['tooltip_soulbound']."%' ORDER BY item.item_name";
	$content .= '<!--  BANK LINE DEBUG:  '.$itemQuery.' -->';
	$DBitemArray = $wowdb->query($itemQuery);
	if (!$DBitemArray)
	{
		print($wowdb->error());
		return $content;
	}
	
	$itemsarray = array();
	while($itemArrayRow = $wowdb->getrow($DBitemArray))
	{
		$itemid_array = explode(':', $itemArrayRow['item_id']);
		$real_itemid = $itemid_array[0].':'.$itemid_array[1].':'.$itemid_array[2];
		$itemsarray[$real_itemid]['item_name'] = $itemArrayRow['item_name'];
		$itemsarray[$real_itemid]['item_color'] = $itemArrayRow['item_color'];
		$itemsarray[$real_itemid]['item_id'] = $itemArrayRow['item_id'];
		$itemsarray[$real_itemid]['item_texture'] = $itemArrayRow['item_texture'];
		$itemsarray[$real_itemid]['item_tooltip'] = $itemArrayRow['item_tooltip'];
		$itemsarray[$real_itemid]['item_parent'] = $itemArrayRow['item_parent'];
		if (!isset($itemsarray[$real_itemid]['quantity']))
		{
			$itemsarray[$real_itemid]['quantity'] = 0;
		}
		$itemsarray[$real_itemid]['quantity'] += $itemArrayRow['item_quantity'];

		// Adding the Per Banker quantity inside the array
		if (!isset($itemsarray[$real_itemid]['banker'][$itemArrayRow['member_id']]))
		{
			$itemsarray[$real_itemid]['banker'][$itemArrayRow['member_id']] = 0;
		}
		$itemsarray[$real_itemid]['banker'][$itemArrayRow['member_id']] += $itemArrayRow['item_quantity'];
	}
	foreach ($itemsarray as $itemid => $itemdetail)
	{
		// Display the icon for the item
		$content .= processItem($itemid, $itemsarray);
	}
	return $content;
}
// This function will process the item and build up the code.
function processItem($real_itemid, $itemsarray)
{
	global $color_border, $itemlink, $roster_conf, $wordings;

	// Add the lead to the item-cell
	$returnstr = '<span style="z-index: 1000;" onMouseover="return overlib(\'';

	// Generate the TOOLTIP code
	$first_line = 1;
	foreach (explode("\n", $itemsarray[$real_itemid]['item_tooltip']) as $line )
	{
		$line = str_replace("\t",'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',$line);
		$class='tooltipline';
		if( $first_line )
		{
			$item_color = substr($itemsarray[$real_itemid]['item_color'], 2, 6 );
			$color = $item_color.'; font-weight: bold';
			$first_line = 0;
			$class='tooltipheader';
		}
		else
		{
			if( substr( $line, 0, 2 ) == '|c' )	{
				$color = substr( $line, 4, 6 ).'; font-size: 10px;';
				$line = substr( $line, 10, -2 );
			}
			else if (isset($wordings[$roster_conf['roster_lang']]['tooltip_use']) && strpos( $line, $wordings[$roster_conf['roster_lang']]['tooltip_use'] ) === 0 )
			{
				$color = '00ff00; font-size: 10px;';
			}
			else if (isset($wordings[$roster_conf['roster_lang']]['tooltip_requires']) && strpos( $line, $wordings[$roster_conf['roster_lang']]['tooltip_requires'] ) === 0 )
			{
				$color = 'ff0000; font-size: 10px;';
			}
			else if (isset($wordings[$roster_conf['roster_lang']]['tooltip_reinforced']) && strpos( $line, $wordings[$roster_conf['roster_lang']]['tooltip_reinforced'] ) === 0 )
			{
				$color = '00ff00; font-size: 10px;';
			}
			else if (isset($wordings[$roster_conf['roster_lang']]['tooltip_equip']) && strpos( $line, $wordings[$roster_conf['roster_lang']]['tooltip_equip'] ) === 0 )
			{
				$color = '00ff00; font-size: 10px;';
			}
			else if (isset($wordings[$roster_conf['roster_lang']]['tooltip_chance']) && strpos( $line, $wordings[$roster_conf['roster_lang']]['tooltip_chance'] ) === 0 )
			{
				$color = '00ff00; font-size: 10px;';
			}
			else if (isset($wordings[$roster_conf['roster_lang']]['tooltip_enchant']) && strpos( $line, $wordings[$roster_conf['roster_lang']]['tooltip_enchant'] ) === 0 )
			{
				$color = '00ff00; font-size: 10px;';
			}
			else if (isset($wordings[$roster_conf['roster_lang']]['tooltip_soulbound']) && strpos( $line, $wordings[$roster_conf['roster_lang']]['tooltip_soulbound'] ) === 0 )
			{
				$color = '00ffff; font-size: 10px;';
			}
			else
			{
				$color='ffffff; font-size: 10px;';
			}
		}
		$line = str_replace(">", "&#8250;", $line);
		$line = str_replace("<", "&#8249;", $line);
		if( $line != '')
		{
			if (!isset($tooltip))
			{
				$tooltip = '';
			}
			$tooltip = $tooltip."<span class=\"".$class."\" style=\"color:#$color\">$line</span><br />";
		}
	}

	// Normalize the tooltip string
	$tooltip = str_replace("'", "\'", $tooltip);
	$tooltip = str_replace('"','&quot;', $tooltip);

	$returnstr .= $tooltip.'\');" onMouseout="return nd();">'."\n";
	// Free Up memory by clearing the tooltip string
	$tooltip = '';

	// Get the Icon Color
	switch ($item_color)
	{
		case "ffffff":
			$item_quality = "iconwhite";
		break;
		case "1eff00":
			$item_quality = "icongreen";
		break;
		case "9d9d9d":
			$item_quality = "icongrey";
		break;
		case "0070dd":
			$item_quality = "iconblue";
		break;
		default:
			$item_quality = "iconpurple";
	}
	$returnstr .= '<div class="item">';

	// Clean the Item Texture of backslashes and replace them with forward slashes
	$item_texture=str_replace('\\','/',$itemsarray[$real_itemid]['item_texture']);

	// Construct the image with a URL and put the colored border around it
	if ($color_border)
	{
		$returnstr .=  '<a href="'.$itemlink[$roster_conf['roster_lang']].urlencode(utf8_decode($itemsarray[$real_itemid]['item_name'])).'" target="_itemlink">'."\n".'<img src="'.$roster_conf['interface_url'].$item_texture.'.'.$roster_conf['img_suffix'].'" class="'.$item_quality.'"></a>';
	}
	else
	{
		$returnstr .=  '<a href="'.$itemlink[$roster_conf['roster_lang']].urlencode(utf8_decode($itemsarray[$real_itemid]['item_name'])).'" target="_itemlink">'."\n".'<img src="'.$roster_conf['interface_url'].$item_texture.'.'.$roster_conf['img_suffix'].'"></a>';
	}
	// If we have more than 1 in total, display the total quantity number on the image
	if (($itemsarray[$real_itemid]['quantity'] > 1) && ($itemsarray[$real_itemid]['item_parent'] != 'bags'))
	{
		$returnstr .= '<span class="quant">'.$itemsarray[$real_itemid]['quantity'].'</span>';
	}
	// Add the trail to the item-cell
	$returnstr .= '</span></div>';

	// Return the complete table cell for the item
	return $returnstr;
}

?>